// File from page 449 in "Thinking in C++" by Bruce Eckel
//////////////////////////////////////////////////
// From the compressed package ECKELT02.ZIP 4/11/95
// (Original ECKELT01.ZIP dated 2/21/95)
// Copyright (c) Bruce Eckel, 1995 
// Source code file from the book "Thinking in C++", 
// Prentice Hall, 1995, ISBN: 0-13-917709-4
// All rights reserved EXCEPT as allowed by the following 
// statements: You may freely use this file for your own 
// work, including modifications and distribution in 
// executable form only. You may copy and distribute this 
// file, as long as it is only distributed in the complete 
// (compressed) package with the other files from this 
// book and you do not remove this copyright and notice. 
// You may not distribute modified versions of the source 
// code in this package. This package may be freely placed 
// on bulletin boards, internet nodes, shareware disks and 
// product vendor disks. You may not use this file in 
// printed media without the express permission of the 
// author. Bruce Eckel makes no 
// representation about the suitability of this software 
// for any purpose. It is provided "as is" without express 
// or implied warranty of any kind. The entire risk as to 
// the quality and performance of the software is with 
// you. Should the software prove defective, you assume 
// the cost of all necessary servicing, repair, or 
// correction. 
// If you think you've found an error, please 
// email all modified files with loudly commented changes 
// to: eckel@aol.com (please use the same 
// address for non-code errors found in the book).
//////////////////////////////////////////////////

//: REFLEX.CPP -- Reflexivity in overloading

class number {
  int i;
public:
  number(int I = 0) { i = I; }
  const number
  operator+(const number& n) const {
    return number(i + n.i);
  }
  friend const number
    operator-(const number&, const number&);
};

const number
  operator-(const number& n1,
            const number& n2) {
    return number(n1.i - n2.i);
}

main() {
  number a(47), b(11);
  a + b; // OK
  a + 1; // 2nd arg converted to number
//! 1 + a; // Wrong! 1st arg not of type number
  a - b; // OK
  a - 1; // 2nd arg converted to number
  1 - a; // 1st arg converted to number
}
