// File from page 660 in "Thinking in C++" by Bruce Eckel
//////////////////////////////////////////////////
// From the compressed package ECKELT02.ZIP 4/11/95
// (Original ECKELT01.ZIP dated 2/21/95)
// Copyright (c) Bruce Eckel, 1995 
// Source code file from the book "Thinking in C++", 
// Prentice Hall, 1995, ISBN: 0-13-917709-4
// All rights reserved EXCEPT as allowed by the following 
// statements: You may freely use this file for your own 
// work, including modifications and distribution in 
// executable form only. You may copy and distribute this 
// file, as long as it is only distributed in the complete 
// (compressed) package with the other files from this 
// book and you do not remove this copyright and notice. 
// You may not distribute modified versions of the source 
// code in this package. This package may be freely placed 
// on bulletin boards, internet nodes, shareware disks and 
// product vendor disks. You may not use this file in 
// printed media without the express permission of the 
// author. Bruce Eckel makes no 
// representation about the suitability of this software 
// for any purpose. It is provided "as is" without express 
// or implied warranty of any kind. The entire risk as to 
// the quality and performance of the software is with 
// you. Should the software prove defective, you assume 
// the cost of all necessary servicing, repair, or 
// correction. 
// If you think you've found an error, please 
// email all modified files with loudly commented changes 
// to: eckel@aol.com (please use the same 
// address for non-code errors found in the book).
//////////////////////////////////////////////////

//: MITHIS.CPP -- MI and the "this" pointer
#include <fstream.h>
ofstream out("mithis.out");

class base1 {
  char c[0x10];
public:
  void printthis1() {
    out << "base1 this = " << this << endl;
  }
};

class base2 {
  char c[0x10];
public:
  void printthis2() {
    out << "base2 this = " << this << endl;
  }
};

class member1 {
  char c[0x10];
public:
  void printthism1() {
    out << "member1 this = " << this << endl;
  }
};

class member2 {
  char c[0x10];
public:
  void printthism2() {
    out << "member2 this = " << this << endl;
  }
};

class mi : public base1, public base2 {
  member1 m1;
  member2 m2;
public:
  void printthis() {
    out << "mi this = " << this << endl;
    printthis1();
    printthis2();
    m1.printthism1();
    m2.printthism2();
  }
};

main() {
  mi MI;
  out << "sizeof(mi) = "
    << hex << sizeof(mi) << " hex" << endl;
  MI.printthis();
  // A second demonstration:
  base1* b1 = &MI; // Upcast
  base2* b2 = &MI; // Upcast
  out << "base 1 pointer = " << b1 << endl;
  out << "base 2 pointer = " << b2 << endl;
}
