// File from page 394 in "Thinking in C++" by Bruce Eckel
//////////////////////////////////////////////////
// From the compressed package ECKELT02.ZIP 4/11/95
// (Original ECKELT01.ZIP dated 2/21/95)
// Copyright (c) Bruce Eckel, 1995 
// Source code file from the book "Thinking in C++", 
// Prentice Hall, 1995, ISBN: 0-13-917709-4
// All rights reserved EXCEPT as allowed by the following 
// statements: You may freely use this file for your own 
// work, including modifications and distribution in 
// executable form only. You may copy and distribute this 
// file, as long as it is only distributed in the complete 
// (compressed) package with the other files from this 
// book and you do not remove this copyright and notice. 
// You may not distribute modified versions of the source 
// code in this package. This package may be freely placed 
// on bulletin boards, internet nodes, shareware disks and 
// product vendor disks. You may not use this file in 
// printed media without the express permission of the 
// author. Bruce Eckel makes no 
// representation about the suitability of this software 
// for any purpose. It is provided "as is" without express 
// or implied warranty of any kind. The entire risk as to 
// the quality and performance of the software is with 
// you. Should the software prove defective, you assume 
// the cost of all necessary servicing, repair, or 
// correction. 
// If you think you've found an error, please 
// email all modified files with loudly commented changes 
// to: eckel@aol.com (please use the same 
// address for non-code errors found in the book).
//////////////////////////////////////////////////

//: PMEM2.CPP -- Pointers to members
#include <iostream.h>

class widget {
  void f(int) const {cout << "widget::f()\n";}
  void g(int) const {cout << "widget::g()\n";}
  void h(int) const {cout << "widget::h()\n";}
  void i(int) const {cout << "widget::i()\n";}
  enum { count = 4 };
  void (widget::*fptr[count])(int) const;
public:
  widget() {
    fptr[0] = &widget::f; // Full spec required
    fptr[1] = &widget::g;
    fptr[2] = &widget::h;
    fptr[3] = &widget::i;
  }
  void select(int I, int J) {
    if(I < 0 || I >= count) return;
    (this->*fptr[I])(J);
  }
  int Count() { return count; }
};

main() {
  widget w;
  for(int i = 0; i < w.Count(); i++)
    w.select(i, 47);
}
