// File from page 764 in "Thinking in C++" by Bruce Eckel
//////////////////////////////////////////////////
// From the compressed package ECKELT02.ZIP 4/11/95
// (Original ECKELT01.ZIP dated 2/21/95)
// Copyright (c) Bruce Eckel, 1995 
// Source code file from the book "Thinking in C++", 
// Prentice Hall, 1995, ISBN: 0-13-917709-4
// All rights reserved EXCEPT as allowed by the following 
// statements: You may freely use this file for your own 
// work, including modifications and distribution in 
// executable form only. You may copy and distribute this 
// file, as long as it is only distributed in the complete 
// (compressed) package with the other files from this 
// book and you do not remove this copyright and notice. 
// You may not distribute modified versions of the source 
// code in this package. This package may be freely placed 
// on bulletin boards, internet nodes, shareware disks and 
// product vendor disks. You may not use this file in 
// printed media without the express permission of the 
// author. Bruce Eckel makes no 
// representation about the suitability of this software 
// for any purpose. It is provided "as is" without express 
// or implied warranty of any kind. The entire risk as to 
// the quality and performance of the software is with 
// you. Should the software prove defective, you assume 
// the cost of all necessary servicing, repair, or 
// correction. 
// If you think you've found an error, please 
// email all modified files with loudly commented changes 
// to: eckel@aol.com (please use the same 
// address for non-code errors found in the book).
//////////////////////////////////////////////////

//: CONCORD.CPP -- Concordance with STL
#include <set.h>
#include <fstream.h>
#include "..\allege.h"
#include "..\14\sstring.h"
const char* delimiters =
  " \t;()\"<>:{}[]+-=&*#.,/\\"
  "0123456789";

main(int argc, char* argv[]) {
  allege(argc == 2, "usage: concord filename");
  ifstream in(argv[1]);
  allegefile(in);
  set<Hstring, less<Hstring> > concordance;
  const sz = 1024;
  char buf[sz];
  while(in.getline(buf,sz)) {
    // Capture individual words:
    char* s = strtok(buf, delimiters);
    while(s) {
      concordance.insert(s); // Auto type conv.
      s = strtok(0, delimiters);
    }
  }
  // output results:
  copy(concordance.begin(), concordance.end(),
       ostream_iterator<Hstring>(cout, "\n"));
}
