#ifndef __BLOCK_PARADOX_TABLE_H_
#define __BLOCK_PARADOX_TABLE_H_

#include "blk.h"
#include "khpxtab.h"

class BlockPXTable : public Block
    {
    public:
	KH_PX_Table* table;
	Element* home_element;
	Element* end_element;
	Element* ok_element;

	BlockPXTable(rect coordinates,           // Screen cells
	       char* tabName,                     // Table name
	       char* fName = "",                  // File for swapping
	       char* h = "",                      // Header text
	       int s = 0,                         // Shadow, pixels
	       BORDERS b_type = SHOW_BORDER,      // Border type
	       BORDERS hdr_b_type = SHOW_BORDER,  // Border around header
	       int res = FIXED,                   // Resize status
	       int hdr_pat = 0,                   // Attention! No window pattern.
	       int elem_pat = 0,                  // Buttons
// Use last 3 arguments for creating new table.
	       int fNo = 0,               // Number of fields in table
	       char** fields = NULL,      // Fields names array
	       char** types = NULL);       // Fields types array

	virtual void hide();
	virtual void rearrange();
    };


#endif __BLOCK_PARADOX_TABLE_H_
