#ifndef __CAPTURE_EDIT_LINE_H_
#define __CAPTURE_EDIT_LINE_H_

#include "editl.h"

enum CAPTURE_POS { C_LEFT, C_TOP, C_RIGHT, C_BOTTOM };

class CaptureEditLine : public EditLine
    {
    protected:
	char* header;
	CAPTURE_POS where;
	int hdr_pat;
    public:
	CaptureEditLine(loc pos, int l, char* hdr = "",
	    CAPTURE_POS wh = C_RIGHT, int max_len = 0,
	    BORDERS b_type = BUTTON_BORDER, int pat = 0, int h_pat = 0,
	    int insert = 1)
	    : 	EditLine(pos, l, max_len, b_type, pat, insert)
	    {
	    header = strdup(hdr);
	    hdr_pat = h_pat;
	    where = wh;
	    }
	~CaptureEditLine() { delete header; }
	virtual void show();
    };

#endif __CAPTURE_EDIT_LINE_H_