#---------------------------------------------------------------------------
#
#       MAKEFILE.MAK: makefile for DOS TSR class.
#       Copyright (c) J.English 1993.
#
#       Permission is granted to use copy and distribute the
#       information contained in this file provided that this
#       copyright notice is retained intact and that any software
#       or other document incorporating this file or parts thereof
#       makes the source code for the TSR class of which this file
#       is a part freely available.
#
#---------------------------------------------------------------------------

.AUTODEPEND
.SILENT

#----- Symbol definitions -----

DIR   = d:\borlandc                 # Borland C++ directory -- change to suit
MODEL = s                           # Memory model (s, m, l, c, h or t)
CC    = bcc -m$(MODEL) -I$(INC)\include -L$(LIB)\lib

#----- Default compilation rule -----

.cpp.obj:
    $(CC) -c $.

#----- Compilation rules -----

all: tick.exe clock.exe protect.exe scrcopy.exe

tick.exe: tick.obj tsr.obj
    $(CC) tick.obj tsr.obj

clock.exe: clock.obj tsr.obj
    $(CC) clock.obj tsr.obj

protect.exe: protect.obj tsr.obj
    $(CC) protect.obj tsr.obj

scrcopy.exe: scrcopy.obj tsr.obj
    $(CC) scrcopy.obj tsr.obj

#----- Other targets -----

clean:                              # clean up directory
    del *.obj

print:                              # print sources
    print tsr.doc makefile.mak *.h *.cpp
